#!/bin/bash

#ESPTOOL_BAUD=2000000

while true; do
	echo -e "\e[96m"
	echo "Install Coolhardware.de ElecPow 1.x (for ESP8266)"
	echo -e "\e[97m"
	echo "i - Display flash chip information"
	echo "b - Create backup of current firmware"
	echo "r - Restore backup"
	echo "q - Quit"
	echo -e "\e[96m"
	echo "Flash ElecPow with the following default pin configuration."
	echo "You can change the pin configuration via the web interface at any time:"
	echo -e "\e[97m"
	echo "0 - Generic ESP8266 without preset"
	echo "1 - Sonoff Pow R2 / SA-001 / Sonoff S31 / WiFi Kit 8"
	echo "2 - Sonoff Pow"
	echo "3 - Gosund SP1 (v2.3+)"
	echo "4 - BlitzWolf BW-SHP2/6 (10A) / Gosund SP111 (v1.4) / GSP1311"
	echo "5 - BlitzWolf BW-SHP6 (15A) / Gosund EP2 / Gosund SP111 (v1.1)"
	echo "6 - Avatto OT08 RGB / XS-A12 / Lonsonho / Vansware"
	echo "7 - Sonoff Pow R3"
	echo -e "\e[0m"

	read -p "Please choose an option: " choice

	case $choice in
		i)
			./esptool flash_id;;

		b)
			if [ -e "backup.bin" ]; then
				echo "The file backup.bin is already present!"
			else
				./esptool read_flash 0 all backup.bin
			fi;;

		r)
			./esptool write_flash --erase-all 0 backup.bin && exit;;

		q)
			exit;;

		0)
			./esptool write_flash --erase-all 0 ESP8266.bin && exit;;

		1)
			./esptool write_flash --erase-all 0 SONOFF_POW_R2.bin && exit;;

		2)
			./esptool write_flash --erase-all 0 SONOFF_POW.bin && exit;;

		3)
			./esptool write_flash --erase-all 0 GOSUND_SP1_V23.bin && exit;;

		4)
			./esptool write_flash --erase-all 0 BLITZWOLF_SHP6_10A.bin && exit;;

		5)
			./esptool write_flash --erase-all 0 BLITZWOLF_SHP6_15A.bin && exit;;

		6)
			./esptool write_flash --erase-all 0 AVATTO_OT08.bin && exit;;

		7)
			./esptool write_flash --erase-all 0 SONOFF_POW_R3.bin && exit;;

		*)
			echo "Invalid option";;
	esac
done
